

#define VERSION "2.3" //vom 4.4.2013 6:36

#define I8    int8_t
#define U8    uint8_t
#define U16   uint16_t
#define I16   int16_t
#define I32   int32_t
#define U32   uint32_t 


#define BIT0 1
#define BIT1 2
#define BIT2 4
#define BIT3 8
#define BIT4 16
#define BIT5 32
#define BIT6 64
#define BIT7 128

#define KANAELE         4
#define EBENEN          5

#define EBENE_NORMAL    0   
#define EBENE_TIMER     1    
#define EBENE_OFEN      2     
#define EBENE_SCHALTUHR 3
#define EBENE_SERVICE   4  

#define KNOPF_OL 0
#define KNOPF_OR 1
#define KNOPF_UL 2
#define KNOPF_UR 3


#define DREH1_A       (PINA & BIT0)
#define DREH1_B       (PINA & BIT1)
#define DREH2_A       (PINA & BIT2)
#define DREH2_B       (PINA & BIT3)
#define DREH3_A       (PINA & BIT4)
#define DREH3_B       (PINA & BIT5)
#define DREH4_A       (PINA & BIT6)
#define DREH4_B       (PINA & BIT7)

#define TASTE_1       (PINB & BIT0)
#define TASTE_2       (PINB & BIT1)
#define TASTE_3       (PINB & BIT2)
#define TASTE_4       (PINB & BIT3)
#define TASTE_TIMER   (PIND & BIT3)
#define TASTE_OFEN    (PIND & BIT2)

#define BEEPER_EIN    (PORTD |= BIT7)
#define BEEPER_AUS    (PORTD &=~BIT7)


/* Bedienpult Layout:

  D1                          D2
       ========DISPLAY======       To  Tt
       ========DISPLAY======
  D3                          D4


  D1..4: Drehgeber mit Tastenfunktion
  To:    Taste Ofen
  Tt:    Taste Timer

  D1..4 werden in Kanal 0..3 behandelt. Ihr Wert steht in  g.iCounter[g.bEbene][0..3] 
*/


#define DI_DCF77_BIT  (PINB & BIT4)
#define DCF77_BIT_GESETZT BIT4

#define RX_BUFFERSIZE 25    //8 Bytes je Telegramm

//#define GRADZEICHEN   223   // -Zeichen im LCD-Zeichensatz Englisch/Japanisch
#define GRADZEICHEN  1        // -Zeichen als selbst definiertes Zeichen
#define DCF77DOT     2        //Blinkender Punkt bei DCf77 Empfang

//-----------------------------------------------------------------------------
typedef struct{
  I16  iCounter[EBENEN][KANAELE];  //5 Ebene, 4 Kanle
  I16  iMin[EBENEN][KANAELE];
  I16  iMax[EBENEN][KANAELE];
  I16  iInc[EBENEN][KANAELE];
  I16  iModulo[EBENEN][KANAELE];
  I16 iTimer[KANAELE];
  I16 iUeberhoehung[KANAELE];
  U8  bEbene; 
  U8  bDcf77Empfang;
  
  U8  bSekunde;
  U8  bMinute;
  U8  bStunde;

  U8  bSendeSollwerte;
  U8  bRefreshDisplay;
  U8  bBlinken;            
  U8  bLichtCounter;
  U8  bZeigeTonAus;
  U8  bBeeperEnabled;
  U8  bBeep;
  U8  mindestPiepsTimer;
  U8  blinkphase;
  U8  mitKern;  //1= Fhler eingesteckt
  

  U8  bFreigabeOfen;
  U8  bAussenV;
  U8  bAussenH;
  U8  bChange;
  U8  bToggle1000ms; //Schaltet alle 1000ms um

  U8 bTasteOfen;
  U8 bTasteTimer;
  U8 bTasteTimerLang;
  U8 bTaste1;
  U8 bTaste2;
  U8 bTaste3;
  U8 bTaste4;
  U8 bEineTaste; //wenn irgendwas gedrckt wurde
  U8 bAbgelaufeneTimer; //Bei abgelaufenem Timer0..3 wird Bit0..3 gesetzt

  U8 RxBuffer[RX_BUFFERSIZE];
  U8 RxBufferWrite;
  U8 RxBufferRead;

  I16 iSchaltuhrDauer;  
  I16 iSchaltuhrEnde;
  
  I16 iNaechsterTimer_s;
  
  I16 iTimeTic1ms;
  I16 iAusgabewert[KANAELE];
  I16 iSpeicher[KANAELE];
  I16 iIdleMs;
  I16 iOfentempRoh;
  I16 iKerntempRoh;
  I16 iOfentempNormiert;
  I16 iKerntempNormiert;
  I16 iOfentempCelsius; //Gefilterte Temperatur
  I16 iKerntempCelsius ;//Gefilterte Temperatur
  I16 iPlatinentempRoh;

}T_global;

extern volatile T_global  g;


/* Prototypen */
void sendStringToLCD(char *str);
void ProcessLCDPanel(void);
void lcdInit(void);
void clearLcd(void);
void home1Lcd(void);
void home2Lcd(void);
void task_dcf77(void);

//EOF
